<?php

/**
 *
 * Enter description here ...
 * @author michael.huebe
 *
 */
class ext_update {
	
	var $table = 'tx_form4socialmedialinks_entry';
	var $llFile = 'LLL:EXT:form4_socialmedialinks/locallang_db.xml';
	
	var $pid;
	var $tcemain;
	var $extConf;
	
	/**
	 *
	 * Main function of the update script.
	 *
	 * @return String
	 */
	public function main() {
		$this->tcemain = t3lib_div::makeInstance('t3lib_tcemain');
		$this->extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['form4_socialmedialinks']);
		
		$this->pid = intval($this->extConf['updateRootId']);

		if ($this->pid > 0) {
			
			$result = $this->importDefaultData();
			
			if ($result) {
				$out = $this->displaySuccess($result);
			}
			
		} else {
			$out = $this->displayWarning();
		}
		
		return $out;
	}
	
	function displaySuccess($result) {
		$out = '
		<div style="padding:15px 15px 20px 0;">
			<div class="typo3-message message-ok">
   				<div class="message-header">' . $GLOBALS['LANG']->sL('LLL:EXT:form4_socialmedialinks/locallang_db.xml:updater.successHeader') . '</div>
  				<div class="message-body">
					' . implode('<br />', $result) . '
				</div>
			</div>
		</div>';

		return $out;
	}
	
	function displayWarning() {
		$out = '
		<div style="padding:15px 15px 20px 0;">
			<div class="typo3-message message-warning">
   				<div class="message-header">' . $GLOBALS['LANG']->sL('LLL:EXT:form4_socialmedialinks/locallang_db.xml:updater.warningHeader') . '</div>
  				<div class="message-body">
					' . $GLOBALS['LANG']->sL('LLL:EXT:form4_socialmedialinks/locallang_db.xml:updater.warningMsg') . '
				</div>
			</div>
		</div>';

		return $out;
	}
	
	/**
	 * This function provides some default entries and inserts it to the database.
	 * It respects just stored records.
	 *
	 * @return Array
	 */
	private function importDefaultData() {
		
		/*
		$sql = '
INSERT INTO tx_form4socialmedialinks_entry VALUES ('1', '0', NOW(), NOW(), '2', '0', '0', '', '', '0', '0', '0', 'SocialSharePrivacy', 'SocialSharePrivacy', '1', '', '', '<script type="text/javascript">\r\njQuery(document).ready(function($){\r\n\r\n$('#socialshareprivacy').socialSharePrivacy({\r\n    services : {\r\n        facebook : {\r\n            'perma_option'  : 'off',\r\n            'dummy_img' : '###SOCIALSHAREPRIVACY_IMG_FACEBOOK###'\r\n        }, \r\n        twitter : {\r\n            'perma_option' : 'off',\r\n            'dummy_img' : '###SOCIALSHAREPRIVACY_IMG_TWITTER###'\r\n        },\r\n        gplus : {\r\n            'perma_option' : 'off',\r\n            'dummy_img' : '###SOCIALSHAREPRIVACY_IMG_GPLUS###'\r\n        }\r\n    },\r\n    'css_path' : '###SOCIALSHAREPRIVACY_CSSFILE###'\r\n});\r\n\r\n});\r\n</script>\r\n <div id="socialshareprivacy"></div>', '0');
INSERT INTO tx_form4socialmedialinks_entry VALUES ('2', '0', NOW(), NOW(), '2', '0', '0', '', '', '0', '0', '0', 'GooglePlus Button', 'GooglePlusSimpleButton', '1', '''', '<script type="text/javascript" src="https://apis.google.com/js/plusone.js"></script>\r\n<g:plusone></g:plusone>', '<script type="text/javascript" src="https://apis.google.com/js/plusone.js"></script>\r\n<g:plusone></g:plusone>', '1');
INSERT INTO tx_form4socialmedialinks_entry VALUES ('3', '0', NOW(), NOW(), '2', '0', '0', '', '', '0', '0', '0', 'FacebookLikeButton', 'FacebookLikeButton', '1', '', '', '<div id="fb-root"></div>\r\n\r\n<script>(function(d, s, id) {\r\n  var js, fjs = d.getElementsByTagName(s)[0];\r\n  if (d.getElementById(id)) return;\r\n  js = d.createElement(s); js.id = id;\r\n  js.src = "//connect.facebook.net/de_DE/all.js#xfbml=1";\r\n  fjs.parentNode.insertBefore(js, fjs);\r\n}(document, 'script', 'facebook-jssdk'));\r\n</script>\r\n\r\n<div class="fb-like" data-send="true" data-width="450" data-show-faces="true"></div>', '0');
INSERT INTO tx_form4socialmedialinks_entry VALUES ('4', '0', NOW(), NOW(), '2', '0', '0', '', '', '0', '0', '0', 'FacebookComments', 'FacebookComments', '1', '', '', '<div id="fb-root"></div>\r\n\r\n<script>(function(d, s, id) {\r\n  var js, fjs = d.getElementsByTagName(s)[0];\r\n  if (d.getElementById(id)) return;\r\n  js = d.createElement(s); js.id = id;\r\n  js.src = "//connect.facebook.net/de_DE/all.js#xfbml=1";\r\n  fjs.parentNode.insertBefore(js, fjs);\r\n}(document, 'script', 'facebook-jssdk'));\r\n</script>\r\n\r\n<div class="fb-comments" data-href="###URL###" data-num-posts="2" data-width="470"></div>', '0');
INSERT INTO tx_form4socialmedialinks_entry VALUES ('5', '0', NOW(), NOW(), '2', '0', '0', '', '', '0', '0', '0', 'TwitterShareLink', 'TwitterShareLink', '1', '', '', '<a href="https://twitter.com/share" class="twitter-share-button">Tweet</a>\r\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="//platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>', '0');
INSERT INTO tx_form4socialmedialinks_entry VALUES ('6', '0', NOW(), NOW(), '2', '0', '0', '', '', '0', '0', '0', 'TwitterFollowMe', 'TwitterFollowMe', '1', '', '', '<a href="https://twitter.com/###TWITTER_FOLLOWME_ACCOUNT###" class="twitter-follow-button" data-show-count="false">Follow @###TWITTER_FOLLOWME_ACCOUNT###</a>\r\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="//platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>', '0');
INSERT INTO tx_form4socialmedialinks_entry VALUES ('7', '0', NOW(), NOW(), '2', '0', '0', '', '', '0', '0', '0', 'TwitterHashtag', 'TwitterHashtag', '1', '', '', '<a href="https://twitter.com/intent/tweet?button_hashtag=TwitterStories" class="twitter-hashtag-button" data-related="username" data-url="http://domain.tdl">Tweet #TwitterStories</a>\r\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="//platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>', '0');
INSERT INTO tx_form4socialmedialinks_entry VALUES ('8', '0', NOW(), NOW(), '2', '0', '0', '', '', '0', '0', '0', 'TwitterMention', 'TwitterMention', '1', '', '', '<a href="https://twitter.com/intent/tweet?screen_name=username" class="twitter-mention-button">Tweet to @username</a>\r\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="//platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>', '0');
		';
		*/
		
		/*
		$item = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'l10n_parent' => '',
			'l10n_diffsource' => '',
			'sorting' => '',
			'deleted' => '0',
			'hidden' => '0',
			'fe_group' => '1',
			'title' => '',
			'identifier' => '',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => '',
			'icon' => '0'
		);
		*/
		
		$items = array();
		$items[] = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'deleted' => '0',
			'hidden' => '0',
			'title' => 'SocialSharePrivacy',
			'identifier' => 'SocialSharePrivacy',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => "<script type=\"text/javascript\">\r\njQuery(document).ready(function($){\r\n\r\n$('#socialshareprivacy').socialSharePrivacy({\r\n    services : {\r\n        facebook : {\r\n            'perma_option'  : 'off',\r\n            'dummy_img' : '###SOCIALSHAREPRIVACY_IMG_FACEBOOK###'\r\n        }, \r\n        twitter : {\r\n            'perma_option' : 'off',\r\n            'dummy_img' : '###SOCIALSHAREPRIVACY_IMG_TWITTER###'\r\n        },\r\n        gplus : {\r\n            'perma_option' : 'off',\r\n            'dummy_img' : '###SOCIALSHAREPRIVACY_IMG_GPLUS###'\r\n        }\r\n    },\r\n    'css_path' : '###SOCIALSHAREPRIVACY_CSSFILE###'\r\n});\r\n\r\n});\r\n</script>\r\n <div id=\"socialshareprivacy\"></div>",
			'icon' => '0'
		);
		
		$items[] = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'deleted' => '0',
			'hidden' => '0',
			'title' => 'GooglePlus Button',
			'identifier' => 'GooglePlus Button',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => "<script type=\"text/javascript\" src=\"https://apis.google.com/js/plusone.js\"></script>\r\n<g:plusone></g:plusone>",
			'icon' => '0'
		);
		
		$items[] = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'deleted' => '0',
			'hidden' => '0',
			'title' => 'FacebookLikeButton',
			'identifier' => 'FacebookLikeButton',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => "<div id=\"fb-root\"></div>\r\n\r\n<script>(function(d, s, id) {\r\n  var js, fjs = d.getElementsByTagName(s)[0];\r\n  if (d.getElementById(id)) return;\r\n  js = d.createElement(s); js.id = id;\r\n  js.src = \"//connect.facebook.net/de_DE/all.js#xfbml=1\";\r\n  fjs.parentNode.insertBefore(js, fjs);\r\n}(document, 'script', 'facebook-jssdk'));\r\n</script>\r\n\r\n<div class=\"fb-like\" data-send=\"true\" data-width=\"450\" data-show-faces=\"true\"></div>",
			'icon' => '0'
		);
		
		$items[] = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'deleted' => '0',
			'hidden' => '0',
			'title' => 'FacebookComments',
			'identifier' => 'FacebookComments',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => "<div id=\"fb-root\"></div>\r\n\r\n<script>(function(d, s, id) {\r\n  var js, fjs = d.getElementsByTagName(s)[0];\r\n  if (d.getElementById(id)) return;\r\n  js = d.createElement(s); js.id = id;\r\n  js.src = \"//connect.facebook.net/de_DE/all.js#xfbml=1\";\r\n  fjs.parentNode.insertBefore(js, fjs);\r\n}(document, 'script', 'facebook-jssdk'));\r\n</script>\r\n\r\n<div class=\"fb-comments\" data-href=\"###URL###\" data-num-posts=\"2\" data-width=\"470\"></div>",
			'icon' => '0'
		);
		
		$items[] = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'deleted' => '0',
			'hidden' => '0',
			'title' => 'TwitterShareLink',
			'identifier' => 'TwitterShareLink',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => "<a href=\"https://twitter.com/share\" class=\"twitter-share-button\">Tweet</a>\r\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"//platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script>",
			'icon' => '0'
		);
		
		$items[] = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'deleted' => '0',
			'hidden' => '0',
			'title' => 'TwitterFollowMe',
			'identifier' => 'TwitterFollowMe',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => "<a href=\"https://twitter.com/###TWITTER_FOLLOWME_ACCOUNT###\" class=\"twitter-follow-button\" data-show-count=\"false\">Follow @###TWITTER_FOLLOWME_ACCOUNT###</a>\r\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"//platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script>",
			'icon' => '0'
		);
		
		$items[] = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'deleted' => '0',
			'hidden' => '0',
			'title' => 'TwitterHashtag',
			'identifier' => 'TwitterHashtag',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => "<a href=\"https://twitter.com/intent/tweet?button_hashtag=TwitterStories\" class=\"twitter-hashtag-button\" data-related=\"username\" data-url=\"http://domain.tdl\">Tweet #TwitterStories</a>\r\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"//platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script>",
			'icon' => '0'
		);
		
		$items[] = array(
			'pid' => $this->pid,
			'tstamp' => time(),
			'crdate' => time(),
			'cruser_id' => $GLOBALS['BE_USER']->user['uid'],
			'sys_language_uid' => '0',
			'deleted' => '0',
			'hidden' => '0',
			'title' => 'TwitterMention',
			'identifier' => 'TwitterMention',
			'type' => '1',
			'description' => '',
			'url' => '',
			'html' => "<a href=\"https://twitter.com/intent/tweet?screen_name=username\" class=\"twitter-mention-button\">Tweet to @username</a>\r\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"//platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script>",
			'icon' => '0'
		);
		
		$results = array();
		
		foreach ($items as $fieldArray) {
			$checkItem = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('COUNT(*) AS itemsExists, pid', $this->table, 'identifier = "' . $fieldArray['identifier'] . '" AND deleted = 0');

			if (is_array($checkItem) && ($checkItem[0]['itemsExists'] > 0 || count($checkItem) > 1)) {
				// do not import this item
				$results[] = 'NO Changes: The social media link: ' . $fieldArray['identifier'] . ' exists. PID: ' . $checkItem[0]['pid'];
			} else {
				// insert tt_content record
				$this->tcemain->start($fieldArray, 'insert');
				$resultDefault = $this->tcemain->insertDB($this->table, 'NEW', $fieldArray);

				if ($resultDefault) {
					$results[] = 'DB Insert: The social media link: ' . $fieldArray['identifier'] . ' is inserted in PID: ' . $this->pid;
				} else {
					$results[] = 'Error DB Insert: The social media link: ' . $fieldArray['identifier'] . ' could not be inserted.';
				}
			}
		}

		return $results;
	}

	/**
	 * Checks how many rows are found and returns true if there are any
	 * (this function is called from the extension manager)
	 *
	 * @param	string		$what: what should be updated
	 * @return	boolean
	 */
	public function access($what = 'all') {
		return TRUE;
	}
	
}
?>